Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/tesselation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -4249,12 +4511,13 @@
     else if (a->endpoints[lowerNra] > b->endpoints[lowerNrb])
       return false;
-    else {  // both lower-numbered endpoints are the same ...
-     if (a->endpoints[(lowerNra+1)%2] < b->endpoints[(lowerNrb+1)%2])
-       return true;
-     else if (a->endpoints[(lowerNra+1)%2] > b->endpoints[(lowerNrb+1)%2])
-       return false;
+    else { // both lower-numbered endpoints are the same ...
+      if (a->endpoints[(lowerNra + 1) % 2] < b->endpoints[(lowerNrb + 1) % 2])
+        return true;
+      else if (a->endpoints[(lowerNra + 1) % 2] > b->endpoints[(lowerNrb + 1) % 2])
+        return false;
     }
     return false;
-  };
+  }
+  ;
 };
 
@@ -4269,21 +4532,20 @@
 IndexToIndex * Tesselation::FindAllDegeneratedLines()
 {
-	Info FunctionInfo(__func__);
-	UniqueLines AllLines;
+  Info FunctionInfo(__func__);
+  UniqueLines AllLines;
   IndexToIndex * DegeneratedLines = new IndexToIndex;
 
   // sanity check
   if (LinesOnBoundary.empty()) {
-    eLog() << Verbose(2) << "FindAllDegeneratedTriangles() was called without any tesselation structure.";
+    DoeLog(2) && (eLog() << Verbose(2) << "FindAllDegeneratedTriangles() was called without any tesselation structure.");
     return DegeneratedLines;
   }
-
   LineMap::iterator LineRunner1;
-  pair< UniqueLines::iterator, bool> tester;
+  pair<UniqueLines::iterator, bool> tester;
   for (LineRunner1 = LinesOnBoundary.begin(); LineRunner1 != LinesOnBoundary.end(); ++LineRunner1) {
-    tester = AllLines.insert( LineRunner1->second );
+    tester = AllLines.insert(LineRunner1->second);
     if (!tester.second) { // found degenerated line
-      DegeneratedLines->insert ( pair<int, int> (LineRunner1->second->Nr, (*tester.first)->Nr) );
-      DegeneratedLines->insert ( pair<int, int> ((*tester.first)->Nr, LineRunner1->second->Nr) );
+      DegeneratedLines->insert(pair<int, int> (LineRunner1->second->Nr, (*tester.first)->Nr));
+      DegeneratedLines->insert(pair<int, int> ((*tester.first)->Nr, LineRunner1->second->Nr));
     }
   }
@@ -4291,5 +4553,5 @@
   AllLines.clear();
 
-  Log() << Verbose(0) << "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines." << endl);
   IndexToIndex::iterator it;
   for (it = DegeneratedLines->begin(); it != DegeneratedLines->end(); it++) {
@@ -4297,7 +4559,7 @@
     const LineMap::const_iterator Line2 = LinesOnBoundary.find((*it).second);
     if (Line1 != LinesOnBoundary.end() && Line2 != LinesOnBoundary.end())
-      Log() << Verbose(0) << *Line1->second << " => " << *Line2->second << endl;
+      DoLog(0) && (Log() << Verbose(0) << *Line1->second << " => " << *Line2->second << endl);
     else
-      eLog() << Verbose(1) << "Either " << (*it).first << " or " << (*it).second << " are not in LinesOnBoundary!" << endl;
+      DoeLog(1) && (eLog() << Verbose(1) << "Either " << (*it).first << " or " << (*it).second << " are not in LinesOnBoundary!" << endl);
   }
 
@@ -4313,8 +4575,7 @@
 IndexToIndex * Tesselation::FindAllDegeneratedTriangles()
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   IndexToIndex * DegeneratedLines = FindAllDegeneratedLines();
   IndexToIndex * DegeneratedTriangles = new IndexToIndex;
-
   TriangleMap::iterator TriangleRunner1, TriangleRunner2;
   LineMap::iterator Liner;
@@ -4331,18 +4592,17 @@
     for (TriangleRunner1 = line1->triangles.begin(); TriangleRunner1 != line1->triangles.end(); ++TriangleRunner1) {
       for (TriangleRunner2 = line2->triangles.begin(); TriangleRunner2 != line2->triangles.end(); ++TriangleRunner2) {
-        if ((TriangleRunner1->second != TriangleRunner2->second)
-          && (TriangleRunner1->second->IsPresentTupel(TriangleRunner2->second))) {
-          DegeneratedTriangles->insert( pair<int, int> (TriangleRunner1->second->Nr, TriangleRunner2->second->Nr) );
-          DegeneratedTriangles->insert( pair<int, int> (TriangleRunner2->second->Nr, TriangleRunner1->second->Nr) );
+        if ((TriangleRunner1->second != TriangleRunner2->second) && (TriangleRunner1->second->IsPresentTupel(TriangleRunner2->second))) {
+          DegeneratedTriangles->insert(pair<int, int> (TriangleRunner1->second->Nr, TriangleRunner2->second->Nr));
+          DegeneratedTriangles->insert(pair<int, int> (TriangleRunner2->second->Nr, TriangleRunner1->second->Nr));
         }
       }
     }
   }
-  delete(DegeneratedLines);
-
-  Log() << Verbose(0) << "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:" << endl;
+  delete (DegeneratedLines);
+
+  DoLog(0) && (Log() << Verbose(0) << "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:" << endl);
   IndexToIndex::iterator it;
   for (it = DegeneratedTriangles->begin(); it != DegeneratedTriangles->end(); it++)
-      Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl);
 
   return DegeneratedTriangles;
@@ -4355,13 +4615,11 @@
 void Tesselation::RemoveDegeneratedTriangles()
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   IndexToIndex * DegeneratedTriangles = FindAllDegeneratedTriangles();
   TriangleMap::iterator finder;
   BoundaryTriangleSet *triangle = NULL, *partnerTriangle = NULL;
-  int count  = 0;
-
-  for (IndexToIndex::iterator TriangleKeyRunner = DegeneratedTriangles->begin();
-    TriangleKeyRunner != DegeneratedTriangles->end(); ++TriangleKeyRunner
-  ) {
+  int count = 0;
+
+  for (IndexToIndex::iterator TriangleKeyRunner = DegeneratedTriangles->begin(); TriangleKeyRunner != DegeneratedTriangles->end(); ++TriangleKeyRunner) {
     finder = TrianglesOnBoundary.find(TriangleKeyRunner->first);
     if (finder != TrianglesOnBoundary.end())
@@ -4380,9 +4638,5 @@
         trianglesShareLine = trianglesShareLine || triangle->lines[i] == partnerTriangle->lines[j];
 
-    if (trianglesShareLine
-      && (triangle->endpoints[1]->LinesCount > 2)
-      && (triangle->endpoints[2]->LinesCount > 2)
-      && (triangle->endpoints[0]->LinesCount > 2)
-    ) {
+    if (trianglesShareLine && (triangle->endpoints[1]->LinesCount > 2) && (triangle->endpoints[2]->LinesCount > 2) && (triangle->endpoints[0]->LinesCount > 2)) {
       // check whether we have to fix lines
       BoundaryTriangleSet *Othertriangle = NULL;
@@ -4404,6 +4658,6 @@
             // the line of triangle receives the degenerated ones
             triangle->lines[i]->triangles.erase(Othertriangle->Nr);
-            triangle->lines[i]->triangles.insert( TrianglePair( partnerTriangle->Nr, partnerTriangle) );
-            for (int k=0;k<3;k++)
+            triangle->lines[i]->triangles.insert(TrianglePair(partnerTriangle->Nr, partnerTriangle));
+            for (int k = 0; k < 3; k++)
               if (triangle->lines[i] == Othertriangle->lines[k]) {
                 Othertriangle->lines[k] = partnerTriangle->lines[j];
@@ -4411,6 +4665,6 @@
               }
             // the line of partnerTriangle receives the non-degenerated ones
-            partnerTriangle->lines[j]->triangles.erase( partnerTriangle->Nr);
-            partnerTriangle->lines[j]->triangles.insert( TrianglePair( Othertriangle->Nr, Othertriangle) );
+            partnerTriangle->lines[j]->triangles.erase(partnerTriangle->Nr);
+            partnerTriangle->lines[j]->triangles.insert(TrianglePair(Othertriangle->Nr, Othertriangle));
             partnerTriangle->lines[j] = triangle->lines[i];
           }
@@ -4418,20 +4672,18 @@
       // erase the pair
       count += (int) DegeneratedTriangles->erase(triangle->Nr);
-      Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *triangle << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *triangle << "." << endl);
       RemoveTesselationTriangle(triangle);
       count += (int) DegeneratedTriangles->erase(partnerTriangle->Nr);
-      Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << "." << endl);
       RemoveTesselationTriangle(partnerTriangle);
     } else {
-      Log() << Verbose(0) << "RemoveDegeneratedTriangles() does not remove triangle " << *triangle
-        << " and its partner " << *partnerTriangle << " because it is essential for at"
-        << " least one of the endpoints to be kept in the tesselation structure." << endl;
-    }
-  }
-  delete(DegeneratedTriangles);
+      DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() does not remove triangle " << *triangle << " and its partner " << *partnerTriangle << " because it is essential for at" << " least one of the endpoints to be kept in the tesselation structure." << endl);
+    }
+  }
+  delete (DegeneratedTriangles);
   if (count > 0)
     LastTriangle = NULL;
 
-  Log() << Verbose(0) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl);
 }
 
@@ -4446,5 +4698,5 @@
 void Tesselation::AddBoundaryPointByDegeneratedTriangle(class TesselPoint *point, LinkedCell *LC)
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   // find nearest boundary point
   class TesselPoint *BackupPoint = NULL;
@@ -4459,8 +4711,8 @@
     NearestBoundaryPoint = PointRunner->second;
   } else {
-    eLog() << Verbose(1) << "I cannot find the boundary point." << endl;
+    DoeLog(1) && (eLog() << Verbose(1) << "I cannot find the boundary point." << endl);
     return;
   }
-  Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl);
 
   // go through its lines and find the best one to split
@@ -4470,11 +4722,10 @@
   class BoundaryLineSet *BestLine = NULL;
   for (LineMap::iterator Runner = NearestBoundaryPoint->lines.begin(); Runner != NearestBoundaryPoint->lines.end(); Runner++) {
-    BaseLine.CopyVector(Runner->second->endpoints[0]->node->node);
-    BaseLine.SubtractVector(Runner->second->endpoints[1]->node->node);
-    CenterToPoint.CopyVector(Runner->second->endpoints[0]->node->node);
-    CenterToPoint.AddVector(Runner->second->endpoints[1]->node->node);
-    CenterToPoint.Scale(0.5);
-    CenterToPoint.SubtractVector(point->node);
-    angle = CenterToPoint.Angle(&BaseLine);
+    BaseLine = (*Runner->second->endpoints[0]->node->node) -
+               (*Runner->second->endpoints[1]->node->node);
+    CenterToPoint = 0.5 * ((*Runner->second->endpoints[0]->node->node) +
+                           (*Runner->second->endpoints[1]->node->node));
+    CenterToPoint -= (*point->node);
+    angle = CenterToPoint.Angle(BaseLine);
     if (fabs(angle - M_PI/2.) < fabs(BestAngle - M_PI/2.)) {
       BestAngle = angle;
@@ -4487,5 +4738,5 @@
   BestLine->triangles.erase(TempTriangle->Nr);
   int nr = -1;
-  for (int i=0;i<3; i++) {
+  for (int i = 0; i < 3; i++) {
     if (TempTriangle->lines[i] == BestLine) {
       nr = i;
@@ -4495,45 +4746,46 @@
 
   // create new triangle to connect point (connects automatically with the missing spot of the chosen line)
-  Log() << Verbose(2) << "Adding new triangle points."<< endl;
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle points." << endl);
   AddTesselationPoint((BestLine->endpoints[0]->node), 0);
   AddTesselationPoint((BestLine->endpoints[1]->node), 1);
   AddTesselationPoint(point, 2);
-  Log() << Verbose(2) << "Adding new triangle lines."<< endl;
-  AddTesselationLine(TPS[0], TPS[1], 0);
-  AddTesselationLine(TPS[0], TPS[2], 1);
-  AddTesselationLine(TPS[1], TPS[2], 2);
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle lines." << endl);
+  AddTesselationLine(NULL, NULL, TPS[0], TPS[1], 0);
+  AddTesselationLine(NULL, NULL, TPS[0], TPS[2], 1);
+  AddTesselationLine(NULL, NULL, TPS[1], TPS[2], 2);
   BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
   BTS->GetNormalVector(TempTriangle->NormalVector);
   BTS->NormalVector.Scale(-1.);
-  Log() << Verbose(1) << "INFO: NormalVector of new triangle is " << BTS->NormalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: NormalVector of new triangle is " << BTS->NormalVector << "." << endl);
   AddTesselationTriangle();
 
   // create other side of this triangle and close both new sides of the first created triangle
-  Log() << Verbose(2) << "Adding new triangle points."<< endl;
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle points." << endl);
   AddTesselationPoint((BestLine->endpoints[0]->node), 0);
   AddTesselationPoint((BestLine->endpoints[1]->node), 1);
   AddTesselationPoint(point, 2);
-  Log() << Verbose(2) << "Adding new triangle lines."<< endl;
-  AddTesselationLine(TPS[0], TPS[1], 0);
-  AddTesselationLine(TPS[0], TPS[2], 1);
-  AddTesselationLine(TPS[1], TPS[2], 2);
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle lines." << endl);
+  AddTesselationLine(NULL, NULL, TPS[0], TPS[1], 0);
+  AddTesselationLine(NULL, NULL, TPS[0], TPS[2], 1);
+  AddTesselationLine(NULL, NULL, TPS[1], TPS[2], 2);
   BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
   BTS->GetNormalVector(TempTriangle->NormalVector);
-  Log() << Verbose(1) << "INFO: NormalVector of other new triangle is " << BTS->NormalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: NormalVector of other new triangle is " << BTS->NormalVector << "." << endl);
   AddTesselationTriangle();
 
   // add removed triangle to the last open line of the second triangle
-  for (int i=0;i<3;i++) { // look for the same line as BestLine (only it's its degenerated companion)
+  for (int i = 0; i < 3; i++) { // look for the same line as BestLine (only it's its degenerated companion)
     if ((BTS->lines[i]->ContainsBoundaryPoint(BestLine->endpoints[0])) && (BTS->lines[i]->ContainsBoundaryPoint(BestLine->endpoints[1]))) {
-      if (BestLine == BTS->lines[i]){
-        eLog() << Verbose(0) << "BestLine is same as found line, something's wrong here!" << endl;
+      if (BestLine == BTS->lines[i]) {
+        DoeLog(0) && (eLog() << Verbose(0) << "BestLine is same as found line, something's wrong here!" << endl);
         performCriticalExit();
       }
-      BTS->lines[i]->triangles.insert( pair<int, class BoundaryTriangleSet *> (TempTriangle->Nr, TempTriangle) );
+      BTS->lines[i]->triangles.insert(pair<int, class BoundaryTriangleSet *> (TempTriangle->Nr, TempTriangle));
       TempTriangle->lines[nr] = BTS->lines[i];
       break;
     }
   }
-};
+}
+;
 
 /** Writes the envelope to file.
@@ -4544,5 +4796,5 @@
 void Tesselation::Output(const char *filename, const PointCloud * const cloud)
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   ofstream *tempstream = NULL;
   string NameofTempFile;
@@ -4550,17 +4802,17 @@
 
   if (LastTriangle != NULL) {
-    sprintf(NumberName, "-%04d-%s_%s_%s", (int)TrianglesOnBoundary.size(), LastTriangle->endpoints[0]->node->Name, LastTriangle->endpoints[1]->node->Name, LastTriangle->endpoints[2]->node->Name);
+    sprintf(NumberName, "-%04d-%s_%s_%s", (int) TrianglesOnBoundary.size(), LastTriangle->endpoints[0]->node->Name, LastTriangle->endpoints[1]->node->Name, LastTriangle->endpoints[2]->node->Name);
     if (DoTecplotOutput) {
       string NameofTempFile(filename);
       NameofTempFile.append(NumberName);
-      for(size_t npos = NameofTempFile.find_first_of(' '); npos != string::npos; npos = NameofTempFile.find(' ', npos))
-      NameofTempFile.erase(npos, 1);
+      for (size_t npos = NameofTempFile.find_first_of(' '); npos != string::npos; npos = NameofTempFile.find(' ', npos))
+        NameofTempFile.erase(npos, 1);
       NameofTempFile.append(TecplotSuffix);
-      Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+      DoLog(0) && (Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n");
       tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
       WriteTecplotFile(tempstream, this, cloud, TriangleFilesWritten);
       tempstream->close();
       tempstream->flush();
-      delete(tempstream);
+      delete (tempstream);
     }
 
@@ -4568,8 +4820,8 @@
       string NameofTempFile(filename);
       NameofTempFile.append(NumberName);
-      for(size_t npos = NameofTempFile.find_first_of(' '); npos != string::npos; npos = NameofTempFile.find(' ', npos))
-      NameofTempFile.erase(npos, 1);
+      for (size_t npos = NameofTempFile.find_first_of(' '); npos != string::npos; npos = NameofTempFile.find(' ', npos))
+        NameofTempFile.erase(npos, 1);
       NameofTempFile.append(Raster3DSuffix);
-      Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+      DoLog(0) && (Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n");
       tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
       WriteRaster3dFile(tempstream, this, cloud);
@@ -4577,13 +4829,16 @@
       tempstream->close();
       tempstream->flush();
-      delete(tempstream);
+      delete (tempstream);
     }
   }
   if (DoTecplotOutput || DoRaster3DOutput)
     TriangleFilesWritten++;
-};
-
-struct BoundaryPolygonSetCompare {
-  bool operator()(const BoundaryPolygonSet * s1, const BoundaryPolygonSet * s2) const {
+}
+;
+
+struct BoundaryPolygonSetCompare
+{
+  bool operator()(const BoundaryPolygonSet * s1, const BoundaryPolygonSet * s2) const
+  {
     if (s1->endpoints.size() < s2->endpoints.size())
       return true;
@@ -4614,36 +4869,35 @@
 {
   Info FunctionInfo(__func__);
-
   /// 2. Go through all BoundaryPointSet's, check their triangles' NormalVector
   IndexToIndex *DegeneratedTriangles = FindAllDegeneratedTriangles();
-  set < BoundaryPointSet *> EndpointCandidateList;
-  pair < set < BoundaryPointSet *>::iterator, bool > InsertionTester;
-  pair < map < int, Vector *>::iterator, bool > TriangleInsertionTester;
+  set<BoundaryPointSet *> EndpointCandidateList;
+  pair<set<BoundaryPointSet *>::iterator, bool> InsertionTester;
+  pair<map<int, Vector *>::iterator, bool> TriangleInsertionTester;
   for (PointMap::const_iterator Runner = PointsOnBoundary.begin(); Runner != PointsOnBoundary.end(); Runner++) {
-    Log() << Verbose(0) << "Current point is " << *Runner->second << "." << endl;
-    map < int, Vector *> TriangleVectors;
+    DoLog(0) && (Log() << Verbose(0) << "Current point is " << *Runner->second << "." << endl);
+    map<int, Vector *> TriangleVectors;
     // gather all NormalVectors
-    Log() << Verbose(1) << "Gathering triangles ..." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Gathering triangles ..." << endl);
     for (LineMap::const_iterator LineRunner = (Runner->second)->lines.begin(); LineRunner != (Runner->second)->lines.end(); LineRunner++)
       for (TriangleMap::const_iterator TriangleRunner = (LineRunner->second)->triangles.begin(); TriangleRunner != (LineRunner->second)->triangles.end(); TriangleRunner++) {
         if (DegeneratedTriangles->find(TriangleRunner->second->Nr) == DegeneratedTriangles->end()) {
-          TriangleInsertionTester = TriangleVectors.insert( pair< int, Vector *> ((TriangleRunner->second)->Nr, &((TriangleRunner->second)->NormalVector)) );
+          TriangleInsertionTester = TriangleVectors.insert(pair<int, Vector *> ((TriangleRunner->second)->Nr, &((TriangleRunner->second)->NormalVector)));
           if (TriangleInsertionTester.second)
-            Log() << Verbose(1) << " Adding triangle " << *(TriangleRunner->second) << " to triangles to check-list." << endl;
+            DoLog(1) && (Log() << Verbose(1) << " Adding triangle " << *(TriangleRunner->second) << " to triangles to check-list." << endl);
         } else {
-          Log() << Verbose(1) << " NOT adding triangle " << *(TriangleRunner->second) << " as it's a simply degenerated one." << endl;
+          DoLog(1) && (Log() << Verbose(1) << " NOT adding triangle " << *(TriangleRunner->second) << " as it's a simply degenerated one." << endl);
         }
       }
     // check whether there are two that are parallel
-    Log() << Verbose(1) << "Finding two parallel triangles ..." << endl;
-    for (map < int, Vector *>::iterator VectorWalker = TriangleVectors.begin(); VectorWalker != TriangleVectors.end(); VectorWalker++)
-      for (map < int, Vector *>::iterator VectorRunner = VectorWalker; VectorRunner != TriangleVectors.end(); VectorRunner++)
+    DoLog(1) && (Log() << Verbose(1) << "Finding two parallel triangles ..." << endl);
+    for (map<int, Vector *>::iterator VectorWalker = TriangleVectors.begin(); VectorWalker != TriangleVectors.end(); VectorWalker++)
+      for (map<int, Vector *>::iterator VectorRunner = VectorWalker; VectorRunner != TriangleVectors.end(); VectorRunner++)
         if (VectorWalker != VectorRunner) { // skip equals
-          const double SCP = VectorWalker->second->ScalarProduct(VectorRunner->second);  // ScalarProduct should result in -1. for degenerated triangles
-          Log() << Verbose(1) << "Checking " << *VectorWalker->second<< " against " << *VectorRunner->second << ": " << SCP << endl;
+          const double SCP = VectorWalker->second->ScalarProduct(*VectorRunner->second); // ScalarProduct should result in -1. for degenerated triangles
+          DoLog(1) && (Log() << Verbose(1) << "Checking " << *VectorWalker->second << " against " << *VectorRunner->second << ": " << SCP << endl);
           if (fabs(SCP + 1.) < ParallelEpsilon) {
             InsertionTester = EndpointCandidateList.insert((Runner->second));
             if (InsertionTester.second)
-              Log() << Verbose(0) << " Adding " << *Runner->second << " to endpoint candidate list." << endl;
+              DoLog(0) && (Log() << Verbose(0) << " Adding " << *Runner->second << " to endpoint candidate list." << endl);
             // and break out of both loops
             VectorWalker = TriangleVectors.end();
@@ -4653,4 +4907,5 @@
         }
   }
+  delete DegeneratedTriangles;
 
   /// 3. Find connected endpoint candidates and put them into a polygon
@@ -4659,9 +4914,9 @@
   BoundaryPointSet *OtherWalker = NULL;
   BoundaryPolygonSet *Current = NULL;
-  stack <BoundaryPointSet*> ToCheckConnecteds;
+  stack<BoundaryPointSet*> ToCheckConnecteds;
   while (!EndpointCandidateList.empty()) {
     Walker = *(EndpointCandidateList.begin());
-    if (Current == NULL) {  // create a new polygon with current candidate
-      Log() << Verbose(0) << "Starting new polygon set at point " << *Walker << endl;
+    if (Current == NULL) { // create a new polygon with current candidate
+      DoLog(0) && (Log() << Verbose(0) << "Starting new polygon set at point " << *Walker << endl);
       Current = new BoundaryPolygonSet;
       Current->endpoints.insert(Walker);
@@ -4676,18 +4931,18 @@
       for (LineMap::const_iterator LineWalker = Walker->lines.begin(); LineWalker != Walker->lines.end(); LineWalker++) {
         OtherWalker = (LineWalker->second)->GetOtherEndpoint(Walker);
-        Log() << Verbose(1) << "Checking " << *OtherWalker << endl;
-        set < BoundaryPointSet *>::iterator Finder = EndpointCandidateList.find(OtherWalker);
-        if (Finder != EndpointCandidateList.end()) {  // found a connected partner
-          Log() << Verbose(1) << " Adding to polygon." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Checking " << *OtherWalker << endl);
+        set<BoundaryPointSet *>::iterator Finder = EndpointCandidateList.find(OtherWalker);
+        if (Finder != EndpointCandidateList.end()) { // found a connected partner
+          DoLog(1) && (Log() << Verbose(1) << " Adding to polygon." << endl);
           Current->endpoints.insert(OtherWalker);
-          EndpointCandidateList.erase(Finder);  // remove from candidates
-          ToCheckConnecteds.push(OtherWalker);  // but check its partners too
+          EndpointCandidateList.erase(Finder); // remove from candidates
+          ToCheckConnecteds.push(OtherWalker); // but check its partners too
         } else {
-          Log() << Verbose(1) << " is not connected to " << *Walker << endl;
+          DoLog(1) && (Log() << Verbose(1) << " is not connected to " << *Walker << endl);
         }
       }
     }
 
-    Log() << Verbose(0) << "Final polygon is " << *Current << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Final polygon is " << *Current << endl);
     ListofDegeneratedPolygons.insert(Current);
     Current = NULL;
@@ -4696,11 +4951,11 @@
   const int counter = ListofDegeneratedPolygons.size();
 
-  Log() << Verbose(0) << "The following " << counter << " degenerated polygons have been found: " << endl;
+  DoLog(0) && (Log() << Verbose(0) << "The following " << counter << " degenerated polygons have been found: " << endl);
   for (UniquePolygonSet::iterator PolygonRunner = ListofDegeneratedPolygons.begin(); PolygonRunner != ListofDegeneratedPolygons.end(); PolygonRunner++)
-    Log() << Verbose(0) << " " << **PolygonRunner << endl;
+    DoLog(0) && (Log() << Verbose(0) << " " << **PolygonRunner << endl);
 
   /// 4. Go through all these degenerated polygons
   for (UniquePolygonSet::iterator PolygonRunner = ListofDegeneratedPolygons.begin(); PolygonRunner != ListofDegeneratedPolygons.end(); PolygonRunner++) {
-    stack <int> TriangleNrs;
+    stack<int> TriangleNrs;
     Vector NormalVector;
     /// 4a. Gather all triangles of this polygon
@@ -4709,6 +4964,6 @@
     // check whether number is bigger than 2, otherwise it's just a simply degenerated one and nothing to do.
     if (T->size() == 2) {
-      Log() << Verbose(1) << " Skipping degenerated polygon, is just a (already simply degenerated) triangle." << endl;
-      delete(T);
+      DoLog(1) && (Log() << Verbose(1) << " Skipping degenerated polygon, is just a (already simply degenerated) triangle." << endl);
+      delete (T);
       continue;
     }
@@ -4719,12 +4974,11 @@
     // connections to either polygon ...
     if (T->size() % 2 != 0) {
-      eLog() << Verbose(0) << " degenerated polygon contains an odd number of triangles, probably contains bridging non-degenerated ones, too!" << endl;
+      DoeLog(0) && (eLog() << Verbose(0) << " degenerated polygon contains an odd number of triangles, probably contains bridging non-degenerated ones, too!" << endl);
       performCriticalExit();
     }
-
-    TriangleSet::iterator TriangleWalker = T->begin();  // is the inner iterator
+    TriangleSet::iterator TriangleWalker = T->begin(); // is the inner iterator
     /// 4a. Get NormalVector for one side (this is "front")
-    NormalVector.CopyVector(&(*TriangleWalker)->NormalVector);
-    Log() << Verbose(1) << "\"front\" defining triangle is " << **TriangleWalker << " and Normal vector of \"front\" side is " << NormalVector << endl;
+    NormalVector = (*TriangleWalker)->NormalVector;
+    DoLog(1) && (Log() << Verbose(1) << "\"front\" defining triangle is " << **TriangleWalker << " and Normal vector of \"front\" side is " << NormalVector << endl);
     TriangleWalker++;
     TriangleSet::iterator TriangleSprinter = TriangleWalker; // is the inner advanced iterator
@@ -4735,52 +4989,50 @@
       triangle = *TriangleWalker;
       TriangleSprinter++;
-      Log() << Verbose(1) << "Current triangle to test for removal: " << *triangle << endl;
-      if (triangle->NormalVector.ScalarProduct(&NormalVector) < 0) { // if from other side, then delete and remove from list
-        Log() << Verbose(1) << " Removing ... " << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Current triangle to test for removal: " << *triangle << endl);
+      if (triangle->NormalVector.ScalarProduct(NormalVector) < 0) { // if from other side, then delete and remove from list
+        DoLog(1) && (Log() << Verbose(1) << " Removing ... " << endl);
         TriangleNrs.push(triangle->Nr);
         T->erase(TriangleWalker);
         RemoveTesselationTriangle(triangle);
       } else
-        Log() << Verbose(1) << " Keeping ... " << endl;
+        DoLog(1) && (Log() << Verbose(1) << " Keeping ... " << endl);
     }
     /// 4c. Copy all "front" triangles but with inverse NormalVector
     TriangleWalker = T->begin();
-    while (TriangleWalker != T->end()) {  // go through all front triangles
-      Log() << Verbose(1) << " Re-creating triangle " << **TriangleWalker << " with NormalVector " << (*TriangleWalker)->NormalVector << endl;
+    while (TriangleWalker != T->end()) { // go through all front triangles
+      DoLog(1) && (Log() << Verbose(1) << " Re-creating triangle " << **TriangleWalker << " with NormalVector " << (*TriangleWalker)->NormalVector << endl);
       for (int i = 0; i < 3; i++)
         AddTesselationPoint((*TriangleWalker)->endpoints[i]->node, i);
-      AddTesselationLine(TPS[0], TPS[1], 0);
-      AddTesselationLine(TPS[0], TPS[2], 1);
-      AddTesselationLine(TPS[1], TPS[2], 2);
+      AddTesselationLine(NULL, NULL, TPS[0], TPS[1], 0);
+      AddTesselationLine(NULL, NULL, TPS[0], TPS[2], 1);
+      AddTesselationLine(NULL, NULL, TPS[1], TPS[2], 2);
       if (TriangleNrs.empty())
-        eLog() << Verbose(0) << "No more free triangle numbers!" << endl;
+        DoeLog(0) && (eLog() << Verbose(0) << "No more free triangle numbers!" << endl);
       BTS = new BoundaryTriangleSet(BLS, TriangleNrs.top()); // copy triangle ...
       AddTesselationTriangle(); // ... and add
       TriangleNrs.pop();
-      BTS->NormalVector.CopyVector(&(*TriangleWalker)->NormalVector);
-      BTS->NormalVector.Scale(-1.);
+      BTS->NormalVector = -1 * (*TriangleWalker)->NormalVector;
       TriangleWalker++;
     }
     if (!TriangleNrs.empty()) {
-      eLog() << Verbose(0) << "There have been less triangles created than removed!" << endl;
-    }
-    delete(T);  // remove the triangleset
-  }
-
+      DoeLog(0) && (eLog() << Verbose(0) << "There have been less triangles created than removed!" << endl);
+    }
+    delete (T); // remove the triangleset
+  }
   IndexToIndex * SimplyDegeneratedTriangles = FindAllDegeneratedTriangles();
-  Log() << Verbose(0) << "Final list of simply degenerated triangles found, containing " << SimplyDegeneratedTriangles->size() << " triangles:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Final list of simply degenerated triangles found, containing " << SimplyDegeneratedTriangles->size() << " triangles:" << endl);
   IndexToIndex::iterator it;
   for (it = SimplyDegeneratedTriangles->begin(); it != SimplyDegeneratedTriangles->end(); it++)
-      Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl;
-  delete(SimplyDegeneratedTriangles);
-
+    DoLog(0) && (Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl);
+  delete (SimplyDegeneratedTriangles);
   /// 5. exit
   UniquePolygonSet::iterator PolygonRunner;
   while (!ListofDegeneratedPolygons.empty()) {
     PolygonRunner = ListofDegeneratedPolygons.begin();
-    delete(*PolygonRunner);
+    delete (*PolygonRunner);
     ListofDegeneratedPolygons.erase(PolygonRunner);
   }
 
   return counter;
-};
+}
+;
